class NUICryptoException implements Exception{

  NUICryptoError cause;
  NUICryptoException({required this.cause});

}

enum NUICryptoError{

  KEY_NOT_FOUND,
  KEY_LENGTH_NOT_MATCH,
  KEY_CANNOT_BE_OVERRIDE,
  PATTERN_NOT_MATCH,
  FILE_TO_ENCRYPT_NOT_FOUND,
  FILE_TYPE_ERROR,
}

extension NUICrpytoErrorExt on NUICryptoError{

  String get cause{
    switch(this){
      case NUICryptoError.KEY_NOT_FOUND : return "Key might not be initialized in the module, set key with setNewKey()";
      case NUICryptoError.KEY_LENGTH_NOT_MATCH : return "Key length not equivalent to 32 bytes / 256 bits";
      case NUICryptoError.KEY_CANNOT_BE_OVERRIDE : return "Key already existed and cannot be override, set key with setNewKey() without using existing key";
      case NUICryptoError.PATTERN_NOT_MATCH : return "The input data for decryption does not meet the required criteria";
      case NUICryptoError.FILE_TO_ENCRYPT_NOT_FOUND : return "File need to be encrypted not found";
      case NUICryptoError.FILE_TYPE_ERROR : return "File extension is not .encrypted, cannot be decrypt";
    }
  }

}