/**
 * Extension of the [Map] class for ease of access to the values
 */
extension MapExt on Map<String, dynamic>{
  /// Getting the non-nullable values from the map based on different data types
  String getString(String key) => this[key] as String;
  int getInt(String key) => this[key] as int;
  double getDouble(String key) => this[key] as double;
  bool getBool(String key) => this[key] as bool;
  List<T> getList<T>(String key) => this[key] as List<T>;
  Map<String, dynamic> getMap(String key) => this[key] as Map<String, dynamic>;
  Map<T, C> getMapSpecific<T, C>(String key) => this[key] as Map<T, C>;

  /// Getting the nullable values from the map based on different data types
  String? getOptString(String key) => this[key] != null ? this[key] as String : null;
  int? getOptInt(String key) => this[key] != null ? this[key] as int : null;
  double? getOptDouble(String key) => this[key] != null ? this[key] as double : null;
  bool? getOptBool(String key) => this[key] != null ? this[key] as bool : null;
  List<T>? getOptList<T>(String key) => this[key] != null ? this[key] as List<T> : null;
  Map<String, dynamic>? getOptMap(String key) => this[key] != null ? this[key] as Map<String, dynamic> : null;
  Map<T, C>? getOptMapSpecific<T, C>(String key) => this[key] != null ? this[key] as Map<T, C> : null;
}