library nui_core;

import 'package:flutter/services.dart';
export 'package:nui_core/system/nui_system.dart';
export 'package:nui_core/bloc/nui_bloc.dart';
export 'package:nui_core/color/nui_color_util.dart';
export 'package:nui_core/color/nui_colors.dart';
export 'package:nui_core/color/nui_gradient_backgrounds.dart';
export 'package:nui_core/data/nui_data_util.dart';
export 'package:nui_core/datetime/nui_dt_util.dart';
export 'package:nui_core/math/nui_math_util.dart';
export 'package:nui_core/bloc/nui_bloc.dart';
export 'package:nui_core/model/enums/gradient_orientation.dart';
export 'package:nui_core/model/gradient_background.dart';
export 'package:nui_core/model/hex_color.dart';
export 'package:nui_core/model/screen_info.dart';
export 'package:nui_core/model/interfaces.dart';
export 'package:nui_core/string/nui_string_util.dart';
export 'package:nui_core/bloc/nui_bloc.dart';
export 'package:nui_core/ui/styling/nui_box_decoration.dart';
export 'package:nui_core/ui/styling/nui_linear_gradient.dart';
export 'package:nui_core/ui/nui_display_util.dart';
export 'package:nui_core/ui/nui_image_util.dart';
export 'package:nui_core/ui/nui_navigator.dart';
export 'package:nui_core/ui/nui_permission_util.dart';
export 'package:nui_core/ui/nui_text_util.dart';
export 'package:nui_core/ui/nui_launcher_util.dart';
export 'package:nui_core/ui/nui_thread_util.dart';
export 'package:nui_core/ui/nui_sharedpref_util.dart';
export 'package:nui_core/code/nui_code_util.dart';
export 'package:nui_core/data/nui_ent.dart';
export 'package:nui_core/ui/component/nui_app.dart';
export 'package:nui_core/ui/component/nui_navigator_page.dart';
export 'package:nui_core/busevent/nui_busevent.dart';

typedef NUIAssetChannel = Future<ByteData> Function(String key);

class NUICore {
  static List<NUIAssetChannel> _assetChannels = [];

  static void setAssetChannel(NUIAssetChannel channel){
    _assetChannels.add(channel);
  }

  static List<NUIAssetChannel> get assetChannels{
    return _assetChannels;
}

  static void clearAssetChannel(){
    _assetChannels.clear();
  }

}
